diff --git a/game/core/src/main/java/net/minecraft/core/world/particle/ParticleEmitterRegistry.java b/game/core/src/main/java/net/minecraft/core/world/particle/ParticleEmitterRegistry.java
new file mode 100644
index 000000000..7e7d6b532
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/particle/ParticleEmitterRegistry.java
@@ -0,0 +1,103 @@
+package net.minecraft.core.world.particle;
+
+import it.unimi.dsi.fastutil.longs.Long2ObjectMap;
+import it.unimi.dsi.fastutil.longs.Long2ObjectOpenHashMap;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+
+import java.util.concurrent.ConcurrentLinkedQueue;
+
+public class ParticleEmitterRegistry {
+
+    private record EmitterNode(TilePos pos, ParticleEmitterRange type) { }
+
+    private final Long2ObjectOpenHashMap<EmitterNode> emitters = new Long2ObjectOpenHashMap<>();
+
+    private final ConcurrentLinkedQueue<EmitterNode> pendingAdds = new ConcurrentLinkedQueue<>();
+    private final ConcurrentLinkedQueue<Long> pendingRemoves = new ConcurrentLinkedQueue<>();
+
+    private long getPosHash(int x, int y, int z) {
+        long hash = x & 0x3FFFFFF;
+        hash |= ((long)(z & 0x3FFFFFF)) << 26;
+        hash |= ((long)(y & 0xFFF)) << 52;
+        return hash;
+    }
+
+    public void add(TilePos pos) {
+        this.add(pos, ParticleEmitterRange.BASIC);
+    }
+
+    public void add(@NotNull TilePos pos, ParticleEmitterRange type) {
+        this.pendingAdds.add(new EmitterNode(new TilePos(pos), type));
+    }
+
+    public void add(TilePosc pos) {
+        this.add(pos, ParticleEmitterRange.BASIC);
+    }
+
+    public void add(@NotNull TilePosc pos, ParticleEmitterRange type) {
+        this.pendingAdds.add(new EmitterNode(new TilePos(pos), type));
+    }
+
+    public void remove(@NotNull TilePos pos) {
+        this.pendingRemoves.add(getPosHash(pos.x(), pos.y(), pos.z()));
+    }
+
+    public void remove(@NotNull TilePosc pos) {
+        this.pendingRemoves.add(getPosHash(pos.x(), pos.y(), pos.z()));
+    }
+
+    public void tick(World world, Player player, int renderDistanceChunks) {
+        while (!this.pendingRemoves.isEmpty()) {
+            this.emitters.remove(this.pendingRemoves.poll().longValue());
+        }
+        while (!this.pendingAdds.isEmpty()) {
+            EmitterNode node = this.pendingAdds.poll();
+            this.emitters.put(getPosHash(node.pos.x(), node.pos.y(), node.pos.z()), node);
+        }
+
+        if (this.emitters.isEmpty()) return;
+
+        var iterator = this.emitters.long2ObjectEntrySet().fastIterator();
+
+        while (iterator.hasNext()) {
+            Long2ObjectMap.Entry<EmitterNode> entry = iterator.next();
+            EmitterNode node = entry.getValue();
+            TilePos pos = node.pos;
+            ParticleEmitterRange type = node.type;
+
+            if (!world.isBlockLoaded(pos)) {
+                iterator.remove();
+                continue;
+            }
+
+            double dx = pos.x() - player.x;
+            double dy = pos.y() - player.y;
+            double dz = pos.z() - player.z;
+            double distSq = dx * dx + dy * dy + dz * dz;
+
+            if (distSq > type.getMaxDistanceSq(renderDistanceChunks)) continue;
+
+            int throttle = 4;
+            if (distSq > 4096) {
+                throttle = 64;
+            } else if (distSq > 1024) {
+                throttle = 16;
+            }
+
+            if (world.rand.nextInt(throttle) == 0) {
+                Block<?> block = world.getBlockType(pos);
+
+                if (block.getLogic().getParticleEmitterRange() != null) {
+                    block.animationTick(world, pos, world.rand);
+                } else {
+                    iterator.remove();
+                }
+            }
+        }
+    }
+}
\ No newline at end of file
diff --git a/game/core/src/main/java/net/minecraft/core/world/pos/TilePos.java b/game/core/src/main/java/net/minecraft/core/world/pos/TilePos.java
index 58453ec8f..303fe2ce7 100644
--- a/game/core/src/main/java/net/minecraft/core/world/pos/TilePos.java
+++ b/game/core/src/main/java/net/minecraft/core/world/pos/TilePos.java
@@ -115,6 +115,20 @@ public final class TilePos implements Externalizable, Cloneable, TilePosc {
         return this;
     }
 
+    public @NotNull TilePos set(final double x, final double y, final double z) {
+        this.x = (int) Math.floor(x);
+        this.y = (int) Math.floor(y);
+        this.z = (int) Math.floor(z);
+        return this;
+    }
+
+    public @NotNull TilePos set(final float x, final float y, final float z) {
+        this.x = (int) Math.floor(x);
+        this.y = (int) Math.floor(y);
+        this.z = (int) Math.floor(z);
+        return this;
+    }
+
     public @NotNull TilePos set(final @NotNull TilePosc pos) {
         this.x = pos.x();
         this.y = pos.y();
diff --git a/game/core/src/main/resources/assets/minecraft/lang/en_US/gamerules.lang b/game/core/src/main/resources/assets/minecraft/lang/en_US/gamerules.lang
index e760fb69a..48e921839 100644
--- a/game/core/src/main/resources/assets/minecraft/lang/en_US/gamerules.lang
+++ b/game/core/src/main/resources/assets/minecraft/lang/en_US/gamerules.lang
@@ -22,6 +22,8 @@ gamerule.do_fire_spread.name=Fire Spread
 gamerule.do_fire_spread.desc=If disabled, fire will not spread.
 gamerule.instant_healing.name=Instant Healing from Food
 gamerule.instant_healing.desc=If enabled, food will heal the player instantly as it did in older versions of BTA!.
+gamerule.acid_melt_rate.name=Acid Melt Rate
+gamerule.acid_melt_rate.desc=Ticks between each acid bank tick, durability melt, and post-exit drain pulse. Default matches fire damage (every 20 ticks). Lower values run faster.
 gamerule.random_tick_speed.name=Random Tick Rate
 gamerule.random_tick_speed.desc=Determines how many blocks are randomly ticked per game tick.
 gamerule.dropped_item_despawn_delay.name=Dropped Item Despawn Delay
diff --git a/game/core/src/main/resources/assets/minecraft/lang/en_US/item.lang b/game/core/src/main/resources/assets/minecraft/lang/en_US/item.lang
index 939eabe0b..fe9875735 100644
--- a/game/core/src/main/resources/assets/minecraft/lang/en_US/item.lang
+++ b/game/core/src/main/resources/assets/minecraft/lang/en_US/item.lang
@@ -490,28 +490,23 @@ item.jar.butterfly.silver.name=Silver Butterfly Jar
 item.jar.butterfly.silver.desc=A glass jar containing a silver butterfly.
 
 item.statue.stone.name=Stone Statue
-item.statue.stone.desc=A decorative stone statue for you to hang your armor.
+item.statue.stone.desc=A decorative statue carved out of stone.
 item.statue.basalt.name=Basalt Statue
-item.statue.basalt.desc=A decorative basalt statue for you to hang your armor.
+item.statue.basalt.desc=A decorative statue carved out of basalt.
 item.statue.limestone.name=Limestone Statue
-item.statue.limestone.desc=A decorative limestone statue for you to hang your armor.
+item.statue.limestone.desc=A decorative statue carved out of limestone.
 item.statue.granite.name=Granite Statue
-item.statue.granite.desc=A decorative granite statue for you to hang your armor.
+item.statue.granite.desc=A decorative statue carved out of granite.
 item.statue.marble.name=Marble Statue
-item.statue.marble.desc=A decorative marble statue for you to hang your armor.
+item.statue.marble.desc=A decorative statue carved out of marble.
 item.statue.pigman.name=Pigman Statue
 item.statue.pigman.desc=An ancient marble statue found in a long-forgotten place.
 
 item.dough.name=Dough
 item.dough.desc=Uncooked dough. Can be baked into bread.
 
-item.rubyglass.crystal.cracked.name=Rubyglass Shards
-item.rubyglass.crystal.cracked.desc=Cracked and full of impurities. But still aesthetically pleasing.
-item.rubyglass.crystal.pure.name=Rubyglass
-item.rubyglass.crystal.pure.desc=A shard of charged Rubyglass crystal, brimming with energy.
-
-item.sulfur.name=Sulfur
-item.sulfur.desc=Highly flammable and yellow. Packs a punch.
+item.rubyglass.name=Rubyglass
+item.rubyglass.desc=A shard of charged rubyglass, brimming with energy.
 
 item.armor.wolf.leather.name=Leather Wolf Armor
 item.armor.wolf.leather.desc=Keep your best friend safe with this soft leather shell.
@@ -525,3 +520,62 @@ item.armor.wolf.gold.name=Gold Wolf Armor
 item.armor.wolf.gold.desc=Keep your best friend fabulous with this shiny gold shell.
 item.armor.wolf.steel.name=Steel Wolf Armor
 item.armor.wolf.steel.desc=Keep your best friend safe with this sturdy steel shell.
+
+
+item.paintbrush.black.name=Black Paintbrush
+item.paintbrush.black.desc=Loaded with black dye and ready for use!
+item.paintbrush.red.name=Red Paintbrush
+item.paintbrush.red.desc=Loaded with red dye and ready for use!
+item.paintbrush.green.name=Green Paintbrush
+item.paintbrush.green.desc=Loaded with green dye and ready for use!
+item.paintbrush.brown.name=Brown Paintbrush
+item.paintbrush.brown.desc=Loaded with brown dye and ready for use!
+item.paintbrush.blue.name=Blue Paintbrush
+item.paintbrush.blue.desc=Loaded with blue dye and ready for use!
+item.paintbrush.purple.name=Purple Paintbrush
+item.paintbrush.purple.desc=Loaded with purple dye and ready for use!
+item.paintbrush.cyan.name=Cyan Paintbrush
+item.paintbrush.cyan.desc=Loaded with cyan dye and ready for use!
+item.paintbrush.silver.name=Light Gray Paintbrush
+item.paintbrush.silver.desc=Loaded with light gray dye and ready for use!
+item.paintbrush.gray.name=Gray Paintbrush
+item.paintbrush.gray.desc=Loaded with gray dye and ready for use!
+item.paintbrush.pink.name=Pink Paintbrush
+item.paintbrush.pink.desc=Loaded with pink dye and ready for use!
+item.paintbrush.yellow.name=Yellow Paintbrush
+item.paintbrush.yellow.desc=Loaded with yellow dye and ready for use!
+item.paintbrush.lime.name=Lime Paintbrush
+item.paintbrush.lime.desc=Loaded with lime dye and ready for use!
+item.paintbrush.lightblue.name=Light Blue Paintbrush
+item.paintbrush.lightblue.desc=Loaded with light blue dye and ready for use!
+item.paintbrush.magenta.name=Magenta Paintbrush
+item.paintbrush.magenta.desc=Loaded with magenta dye and ready for use!
+item.paintbrush.orange.name=Orange Paintbrush
+item.paintbrush.orange.desc=Loaded with orange dye and ready for use!
+item.paintbrush.white.name=White Paintbrush
+item.paintbrush.white.desc=Loaded with white dye and ready for use!
+
+item.statue.slate.name=Slate Statue
+item.statue.slate.desc=A decorative statue carved from slate.
+
+item.statue.permafrost.name=Permafrost Statue
+item.statue.permafrost.desc=A decorative statue carved from freezing permafrost.
+
+item.statue.netherrack.name=Netherrack Statue
+item.statue.netherrack.desc=A decorative statue carved from netherrack.
+
+item.statue.gloomstone.name=Gloomstone Statue
+item.statue.gloomstone.desc=A decorative statue carved from gloomy stone.
+
+item.ammo.arrow.flaming.name=Flaming Arrow
+item.ammo.arrow.flaming.desc=An arrow tipped with highly combustible sulfur.
+
+item.sulfur.name=Sulfur
+item.sulfur.desc=A pungent, flammable powder sourced from acidic pools.
+
+item.bucket.iron.acid.name=Iron Acid Bucket
+item.bucket.iron.acid.desc=A sturdy bucket carefully filled with corrosive acid.
+
+item.bucket.steel.acid.name=Steel Acid Bucket
+item.bucket.steel.acid.desc=A large sturdy bucket carefully filled with corrosive acid.
+
diff --git a/game/core/src/main/resources/assets/minecraft/lang/en_US/options.lang b/game/core/src/main/resources/assets/minecraft/lang/en_US/options.lang
index 1e57d8946..5ec26009f 100644
--- a/game/core/src/main/resources/assets/minecraft/lang/en_US/options.lang
+++ b/game/core/src/main/resources/assets/minecraft/lang/en_US/options.lang
@@ -268,6 +268,7 @@ options.hideDynamicTooltip=Hide
 options.hideHealthBar=Hide
 options.hideOxygenBar=Hide
 options.hideFireBar=Hide
+options.hideAcidBar=Hide
 options.hideVehicleBar=Hide
 
 options.hideHelmetBar=Hide
@@ -296,6 +297,7 @@ options.verticalHealthBar=Vertical
 options.verticalOxygenBar=Vertical
 options.verticalVehicleBar=Vertical
 options.verticalFireBar=Vertical
+options.verticalAcidBar=Vertical
 
 options.flipHeldItemCount=Flip
 options.flipHelmetBar=Flip
@@ -306,6 +308,7 @@ options.flipHealthBar=Flip
 options.flipOxygenBar=Flip
 options.flipVehicleBar=Flip
 options.flipFireBar=Flip
+options.flipAcidBar=Flip
 
 options.horizontalInfoTextAlignment=Horizontal Alignment
 options.horizontalInfoTextAlignment.left=Left
diff --git a/game/core/src/main/resources/assets/minecraft/lang/en_US/tile.lang b/game/core/src/main/resources/assets/minecraft/lang/en_US/tile.lang
index 1f2511f1a..0d97b30e8 100644
--- a/game/core/src/main/resources/assets/minecraft/lang/en_US/tile.lang
+++ b/game/core/src/main/resources/assets/minecraft/lang/en_US/tile.lang
@@ -54,6 +54,8 @@ tile.netherrack.carved.name=Carved Netherrack
 tile.netherrack.carved.desc=Polished Netherrack with lines hewn through the middle.
 tile.gloomstone.carved.name=Carved Gloomstone
 tile.gloomstone.carved.desc=Polished Gloomstone with lines hewn through the middle.
+tile.slate.carved.name=Carved Slate
+tile.slate.carved.desc=Two slabs of polished slate.
 
 tile.planks.oak.name=Wooden Planks
 tile.planks.oak.desc=Processed tree insides.
@@ -235,6 +237,8 @@ tile.brick.stone.desc=Stacked bricks of stone.
 tile.brick.permafrost.name=Permafrost Bricks
 tile.brick.permafrost.desc=Stacked bricks of permafrost.
 
+tile.brick.rubyglass.name=Rubyglass Bricks
+tile.brick.rubyglass.desc=Stacked bricks of rubyglass.
 tile.brick.diamond.name=Diamond Bricks
 tile.brick.diamond.desc=Stacked bricks of diamond.
 tile.brick.iron.name=Iron Bricks
@@ -260,6 +264,8 @@ tile.slab.brick.stone.polished.name=Polished Stone Brick Slab
 tile.slab.brick.stone.polished.desc=A slab of polished stone bricks.
 tile.slab.stone.carved.name=Polished Stone Slab
 tile.slab.stone.carved.desc=A slab of polished stone.
+tile.slab.slate.polished.name=Polished Slate Slab
+tile.slab.slate.polished.desc=A slab of polished slate.
 tile.slab.brick.marble.name=Marble Brick Slab
 tile.slab.brick.marble.desc=A slab of marble bricks.
 tile.slab.brick.clay.name=Clay Brick Slab
@@ -332,6 +338,8 @@ tile.slab.brick.sandstone.desc=A slab of sandstone bricks.
 tile.slab.brick.permafrost.name=Permafrost Brick Slab
 tile.slab.brick.permafrost.desc=A slab of permafrost bricks.
 
+tile.slab.brick.rubyglass.name=Rubyglass Brick Slab
+tile.slab.brick.rubyglass.desc=A slab of rubyglass bricks.
 tile.slab.brick.diamond.name=Diamond Brick Slab
 tile.slab.brick.diamond.desc=A slab of diamond bricks.
 tile.slab.brick.iron.name=Iron Brick Slab
@@ -382,6 +390,8 @@ tile.stairs.brick.sandstone.desc=Sandstone brick block used for rapid vertical m
 tile.stairs.brick.permafrost.name=Permafrost Brick Stairs
 tile.stairs.brick.permafrost.desc=Permafrost brick block used for rapid vertical movement.
 
+tile.stairs.brick.rubyglass.name=Rubyglass Brick Stairs
+tile.stairs.brick.rubyglass.desc=Rubyglass brick block used for rapid vertical movement.
 tile.stairs.brick.diamond.name=Diamond Brick Stairs
 tile.stairs.brick.diamond.desc=Diamond brick block used for rapid vertical movement.
 tile.stairs.brick.iron.name=Iron Brick Stairs
@@ -519,8 +529,6 @@ tile.log.thorn.name=Thorn Log
 tile.log.thorn.desc=A log from a thorn tree.
 tile.log.palm.name=Palm Log
 tile.log.palm.desc=A log from a palm tree.
-tile.log.petrified.name=Petrified Pillar
-tile.log.petrified.desc=A pillar of carbon, encased in hardened ash.
 
 tile.leaves.oak.name=Oak Leaves
 tile.leaves.oak.desc=Leaves from an oak tree.
@@ -1069,19 +1077,19 @@ tile.cobble.netherrack.desc=Dark red rock that burns forever.
 tile.magma.name=Magma
 tile.magma.desc=Lava that's been partially cooled. Melts in extreme heat.
 tile.cobble.netherrack.crystalline.name=Crystalline Netherrack
-tile.cobble.netherrack.crystalline.desc=Netherrack, covered in a web of Rubyglass.
+tile.cobble.netherrack.crystalline.desc=Netherrack, covered in a web of rubyglass.
 tile.netherrack.name=Netherrack
 tile.netherrack.desc=Dark red rock, smoothed by heat and time.
 tile.brick.netherrack.name=Netherrack Bricks
-tile.brick.netherrack.desc=Stacked bricks of Netherrack.
+tile.brick.netherrack.desc=Stacked bricks of netherrack.
 tile.slab.netherrack.carved.name=Polished Netherrack Slab
-tile.slab.netherrack.carved.desc=A slab of polished Netherrack.
+tile.slab.netherrack.carved.desc=A slab of polished netherrack.
 tile.slab.cobble.netherrack.name=Cobbled Netherrack Slab
-tile.slab.cobble.netherrack.desc=A slab of cobbled Netherrack.
+tile.slab.cobble.netherrack.desc=A slab of cobbled netherrack.
 tile.slab.brick.netherrack.name=Netherrack Brick Slab
-tile.slab.brick.netherrack.desc=A slab of Netherrack bricks.
+tile.slab.brick.netherrack.desc=A slab of netherrack bricks.
 tile.stairs.cobble.netherrack.name=Cobbled Netherrack Stairs
-tile.stairs.cobble.netherrack.desc=Cobbled Netherrack block used for rapid vertical movement.
+tile.stairs.cobble.netherrack.desc=Cobbled netherrack block used for rapid vertical movement.
 tile.stairs.brick.netherrack.name=Netherrack Brick Stairs
 tile.stairs.brick.netherrack.desc=Netherrack brick block used for rapid vertical movement.
 
@@ -1433,25 +1441,23 @@ tile.rope.name=Rope
 tile.rope.desc=Rope, rope, rope your boat.
 
 tile.rubyglass.column.name=Rubyglass Column
-tile.rubyglass.column.desc=A column of tightly packed Rubyglass.
-
+tile.rubyglass.column.desc=A column of tightly packed rubyglass.
 tile.rubyglass.node.name=Rubyglass Node
-tile.rubyglass.node.desc=A dense outcrop of Rubyglass. Crystals harvested from this node are purer and more powerful than usual.
-
+tile.rubyglass.node.desc=A dense outcrop yeilding pure rubyglass.
 tile.block.rubyglass.name=Block of Rubyglass
-tile.block.rubyglass.desc=A translucent glass-like crystal brimming with energy.
-
-tile.rubyglass.sprout.name=Rubyglass Bud
-tile.rubyglass.sprout.desc=A small bud of rubyglass, branching out in many directions.
-
+tile.block.rubyglass.desc=A bright pink crystal brimming with energy.
 tile.rubyglass.conduit.name=Conduit
-tile.rubyglass.conduit.desc=Netherrack etched with lines of rubyglass. It resonates with latent power.
+tile.rubyglass.conduit.desc=Netherrack powered by lines of etched rubyglass using redstone as a catalyst.
+tile.rubyglass.growth.name=Rubyglass Growth
+tile.rubyglass.growth.desc=A squared, crystalline formation of rubyglass.
+tile.rubyglass.crystal.name=Rubyglass Crystal
+tile.rubyglass.crystal.desc=Thin glass crystal with the crimson hue of rubyglass.
 
-tile.vent.name=Chimney
-tile.vent.desc=A rocky column that emits a stream of smoke.
+tile.vent.name=Thermal Vent
+tile.vent.desc=An explosive, geothermal column amplified by its length.
 
 tile.bone_pile.name=Bone Pile
-tile.bone_pile.desc=A pile of solid calcium.
+tile.bone_pile.desc=A pile of bones.
 tile.soul_catcher.name=Soul Catcher
 tile.soul_catcher.desc=Tendrils of soul sand that seemingly move on their own. Hard to walk through.
 
@@ -1465,34 +1471,78 @@ tile.jar.butterfly.silver.name=Silver Butterfly Jar
 tile.jar.butterfly.silver.desc=A glass jar containing a silver butterfly.
 
 tile.statue.stone.lower.name=Stone Statue (Lower)
-tile.statue.stone.lower.desc=
+tile.statue.stone.lower.desc=How?
 tile.statue.stone.upper.name=Stone Statue (Upper)
-tile.statue.stone.upper.desc=
+tile.statue.stone.upper.desc=How?
 tile.statue.basalt.lower.name=Basalt Statue (Lower)
-tile.statue.basalt.lower.desc=
+tile.statue.basalt.lower.desc=How?
 tile.statue.basalt.upper.name=Basalt Statue (Upper)
-tile.statue.basalt.upper.desc=
+tile.statue.basalt.upper.desc=How?
 tile.statue.limestone.lower.name=Limestone Statue (Lower)
-tile.statue.limestone.lower.desc=
+tile.statue.limestone.lower.desc=How?
 tile.statue.limestone.upper.name=Limestone Statue (Upper)
-tile.statue.limestone.upper.desc=
+tile.statue.limestone.upper.desc=How?
 tile.statue.granite.lower.name=Granite Statue (Lower)
-tile.statue.granite.lower.desc=
+tile.statue.granite.lower.desc=How?
 tile.statue.granite.upper.name=Granite Statue (Upper)
-tile.statue.granite.upper.desc=
+tile.statue.granite.upper.desc=How?
 tile.statue.marble.lower.name=Marble Statue (Lower)
-tile.statue.marble.lower.desc=
+tile.statue.marble.lower.desc=How?
 tile.statue.marble.upper.name=Marble Statue (Upper)
-tile.statue.marble.upper.desc=
+tile.statue.marble.upper.desc=How?
 tile.statue.pigman.lower.name=Pigman Statue (Lower)
-tile.statue.pigman.lower.desc=
+tile.statue.pigman.lower.desc=How?
 tile.statue.pigman.upper.name=Pigman Statue (Upper)
-tile.statue.pigman.upper.desc=
+tile.statue.pigman.upper.desc=How?
 
 tile.matcher.name=Matcher
 tile.matcher.desc=Matches the block in front to the block behind.
 tile.matcher.active.name=Matcher
 tile.matcher.desc=Matches the block in front to the block behind.
 
-tile.flowstone.name=Flowstone
-tile.flowstone.desc=A rocky growth formed over millennia.
\ No newline at end of file
+tile.log.scorched.name=Scorched Log
+tile.log.scorched.desc=A severely burnt log, charred black by intense heat.
+
+tile.brimstone.name=Brimstone
+tile.brimstone.desc=Compacted brimsand.
+
+tile.slab.brimstone.name=Brimstone Slab
+tile.slab.brimstone.desc=A slab of brimstone.
+
+tile.stairs.brimstone.name=Brimstone Stairs
+tile.stairs.brimstone.desc=Brimstone block used for rapid vertical movement.
+
+tile.brick.brimstone.name=Brimstone Bricks
+tile.brick.brimstone.desc=Stacked bricks of Brimstone.
+
+tile.slab.brick.brimstone.name=Brimstone Brick Slab
+tile.slab.brick.brimstone.desc=A slab of brimstone bricks.
+
+tile.stairs.brick.brimstone.name=Brimstone Brick Stairs
+tile.stairs.brick.brimstone.desc=Brimstone brick block used for rapid vertical movement.
+
+tile.sulfur.name=Block of Sulfur
+tile.sulfur.desc=A foul-smelling block of concentrated sulfur.
+
+tile.sulfur_hardened.name=Hardened Block of Sulfur
+tile.sulfur_hardened.desc=A rough, foul-smelling block of concentrated sulfur.
+
+tile.chain.iron.large.name=Iron Chain
+tile.chain.iron.large.desc=A heavy iron chain.
+tile.chain.steel.name=Steel Chain
+tile.chain.steel.desc=A durable steel chain.
+
+tile.boulder.magmatic.name=Magmatic Boulder
+tile.boulder.magmatic.desc=A large magmatic rock.
+
+tile.boulder.sulfuric.name=Sulfuric Boulder
+tile.boulder.sulfuric.desc=A large sulfuric rock.
+
+tile.brimthaw.name=Brimthaw
+tile.brimthaw.desc=Brimstone laced with glowing rock.
+
+tile.ember.name=Ember
+tile.ember.desc=Smoldering, explosive remnants of a forgotten world.
+
+tile.acid.name=Acid
+tile.acid.desc=A highly corrosive, sulfuric fluid.
\ No newline at end of file
diff --git a/game/core/src/test/java/TestFlammables.java b/game/core/src/test/java/TestFlammables.java
index c662cff05..73c5baf96 100644
--- a/game/core/src/test/java/TestFlammables.java
+++ b/game/core/src/test/java/TestFlammables.java
@@ -24,10 +24,16 @@ public class TestFlammables {
                 Block.hasLogicClass(block, BlockLogicLog.class) ||
                 Block.hasLogicClass(block, BlockLogicLeavesBase.class) ||
                 Block.hasLogicClass(block, BlockLogicMoss.class);
+
             boolean shouldSmelt =
                 Block.hasLogicClass(block, BlockLogicLog.class) ||
                 Block.hasLogicClass(block, BlockLogicSaplingBase.class);
 
+            if (block == Blocks.LOG_SCORCHED){
+                shouldCombust = false;
+                shouldSmelt = false;
+            }
+
             if (shouldCombust) {
                 Assertions.assertTrue(BlockLogicFire.canBurn(block.id()), () -> "Block '" + block.namespaceId() + "' of class '" + block.getLogic().getClass() + "' should probably be flammable!");
             }
diff --git a/util/datagen/src/main/java/net/minecraft/datagen/SmeltingGenerator.java b/util/datagen/src/main/java/net/minecraft/datagen/SmeltingGenerator.java
index 5c4ecdee4..96b7562d4 100644
--- a/util/datagen/src/main/java/net/minecraft/datagen/SmeltingGenerator.java
+++ b/util/datagen/src/main/java/net/minecraft/datagen/SmeltingGenerator.java
@@ -28,7 +28,7 @@ public class SmeltingGenerator {
 
         sharedRecipe("raw_iron_to_iron_ingot", Items.ORE_RAW_IRON.getDefaultStack(), Items.INGOT_IRON.getDefaultStack());
         sharedRecipe("raw_gold_to_gold_ingot", Items.ORE_RAW_GOLD.getDefaultStack(), Items.INGOT_GOLD.getDefaultStack());
-        
+
         furnaceRecipe("dough_to_bread", Items.DOUGH.getDefaultStack(), Items.FOOD_BREAD.getDefaultStack());
         furnaceRecipe("fish_raw_to_fish_cooked", Items.FOOD_FISH_RAW.getDefaultStack(), Items.FOOD_FISH_COOKED.getDefaultStack());
         furnaceRecipe("porkchop_raw_to_porkchop_cooked", Items.FOOD_PORKCHOP_RAW.getDefaultStack(), Items.FOOD_PORKCHOP_COOKED.getDefaultStack());
@@ -42,16 +42,30 @@ public class SmeltingGenerator {
         furnaceRecipe("cobble_permafrost_to_permafrost", Blocks.COBBLE_PERMAFROST.getDefaultStack(), Blocks.PERMAFROST.getDefaultStack());
         furnaceRecipe("cobble_gloomstone_to_gloomstone", Blocks.COBBLE_GLOOMSTONE.getDefaultStack(), Blocks.GLOOMSTONE.getDefaultStack());
 
+        blastRecipe("cobble_stone_to_slate", Blocks.COBBLE_STONE.getDefaultStack(), Blocks.SLATE.getDefaultStack());
+        blastRecipe("cobble_stone_to_stone", Blocks.COBBLE_STONE.getDefaultStack(), Blocks.COBBLE_STONE.getDefaultStack(), Blocks.STONE.getDefaultStack());
+
         blastRecipe("cobble_basalt_to_olivine", Blocks.COBBLE_BASALT.getDefaultStack(), Items.OLIVINE.getDefaultStack());
+        blastRecipe("cobble_basalt_to_basalt", Blocks.COBBLE_BASALT.getDefaultStack(), Blocks.COBBLE_BASALT.getDefaultStack(), Blocks.BASALT.getDefaultStack());
+
         blastRecipe("cobble_granite_to_quartz", Blocks.COBBLE_GRANITE.getDefaultStack(), Items.QUARTZ.getDefaultStack());
+        blastRecipe("cobble_granite_to_granite", Blocks.COBBLE_GRANITE.getDefaultStack(), Blocks.COBBLE_GRANITE.getDefaultStack(), Blocks.GRANITE.getDefaultStack());
+
         blastRecipe("cobble_limestone_to_marble", Blocks.COBBLE_LIMESTONE.getDefaultStack(), Blocks.MARBLE.getDefaultStack());
+        blastRecipe("cobble_limestone_to_limestone", Blocks.COBBLE_LIMESTONE.getDefaultStack(), Blocks.COBBLE_LIMESTONE.getDefaultStack(), Blocks.LIMESTONE.getDefaultStack());
+
+        blastRecipe("cobble_netherrack_to_magma", Blocks.COBBLE_NETHERRACK.getDefaultStack(), Blocks.MAGMA.getDefaultStack());
+        blastRecipe("cobble_netherrack_to_netherrack", Blocks.COBBLE_NETHERRACK.getDefaultStack(), Blocks.COBBLE_NETHERRACK.getDefaultStack(), Blocks.NETHERRACK.getDefaultStack());
+
+        blastRecipe("brimstone_to_brimthaw", Blocks.BRIMSTONE.getDefaultStack(), Blocks.BRIMTHAW.getDefaultStack());
+
         blastRecipe("cobble_permafrost_to_permafrost", Blocks.COBBLE_PERMAFROST.getDefaultStack(), Blocks.PERMAFROST.getDefaultStack());
-        blastRecipe("cobble_stone_to_slate", Blocks.COBBLE_STONE.getDefaultStack(), Blocks.SLATE.getDefaultStack());
+        blastRecipe("cobble_gloomstone_to_gloomstone", Blocks.COBBLE_GLOOMSTONE.getDefaultStack(), Blocks.GLOOMSTONE.getDefaultStack());
+
         blastRecipe("iron_ingot_and_coal_to_crude_steel", Items.INGOT_IRON.getDefaultStack(), Items.COAL.getDefaultStack(), Items.INGOT_STEEL_CRUDE.getDefaultStack());
         blastRecipe("iron_ingot_and_charcoal_to_crude_steel", Items.INGOT_IRON.getDefaultStack(), new ItemStack(Items.COAL, 1, 1), Items.INGOT_STEEL_CRUDE.getDefaultStack());
-        blastRecipe("cobble_netherrack_to_magma", Blocks.COBBLE_NETHERRACK.getDefaultStack(), Blocks.MAGMA.getDefaultStack());
-        blastRecipe("logs_to_petrified_pillar", "minecraft:logs", Blocks.BLOCK_ASH.getDefaultStack(), Blocks.LOG_PETRIFIED.getDefaultStack());
 
+        blastRecipe("log_to_scorched_log", "minecraft:logs", Blocks.BLOCK_ASH.getDefaultStack(), Blocks.LOG_SCORCHED.getDefaultStack());
     }
 
     private static void furnaceRecipe(String id, ItemStack input, ItemStack output) {
diff --git a/util/datagen/src/main/java/net/minecraft/datagen/TrommelGenerator.java b/util/datagen/src/main/java/net/minecraft/datagen/TrommelGenerator.java
index 1190892b3..095655ba5 100644
--- a/util/datagen/src/main/java/net/minecraft/datagen/TrommelGenerator.java
+++ b/util/datagen/src/main/java/net/minecraft/datagen/TrommelGenerator.java
@@ -78,19 +78,30 @@ public class TrommelGenerator {
             .addEntry(new WeightedRandomLootObject(new ItemStack(Items.ORE_RAW_GOLD), 1), 2)
             .addEntry(new WeightedRandomLootObject(new ItemStack(Items.ORE_RAW_IRON), 1), 1)
             .addEntry(new WeightedRandomLootObject(new ItemStack(Items.DUST_GLOWSTONE), 1, 6), 5)
-//            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.RUBYGLASS_DUST), 1, 3), 5)
             .addEntry(new WeightedRandomLootObject(new ItemStack(Items.NETHERCOAL), 1), 2)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.AMMO_PEBBLE), 1, 2), 15)
             .create("soul_sand");
 
         RecipeBuilder.Trommel(RecipesGenerator.CORE_NAMESPACE)
-                .setInput(Blocks.BRIMSAND)
-                .addEntry(new WeightedRandomLootObject(new ItemStack(Items.GUNPOWDER), 1, 2), 25)
-                .addEntry(new WeightedRandomLootObject(new ItemStack(Items.BONE), 1, 2), 10)
-                .addEntry(new WeightedRandomLootObject(new ItemStack(Items.DUST_GLOWSTONE), 1, 4), 5)
-                .addEntry(new WeightedRandomLootObject(new ItemStack(Items.FLINT), 1, 2), 5)
-                .addEntry(new WeightedRandomLootObject(new ItemStack(Items.OLIVINE), 1), 5)
-                .addEntry(new WeightedRandomLootObject(new ItemStack(Items.ORE_RAW_GOLD), 1), 0.5)
-                .create("brimsand");
+            .setInput(Blocks.BRIMSAND)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.AMMO_PEBBLE), 2, 3), 35)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.GUNPOWDER), 1, 2), 25)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.BONE), 1, 2), 10)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.DUST_GLOWSTONE), 1, 2), 10)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.FLINT), 1, 2), 5)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.SULFUR), 1, 2), 5)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.NETHERCOAL), 1), 5)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.ORE_RAW_GOLD), 1), 0.5)
+            .create("brimsand");
+
+        RecipeBuilder.Trommel(RecipesGenerator.CORE_NAMESPACE)
+            .setInput(Blocks.SULFUR)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.SULFUR), 2, 5), 30)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.DUST_GLOWSTONE), 1, 3), 20)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.BONE), 1, 2), 10)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.FLINT), 1, 2), 5)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.ORE_RAW_IRON), 1, 2), 4)
+            .create("sulfur");
 
     }
 }
